<template>
  <form @submit="onSubmit">
      <div class="row mb-2">
        <div class="col-lg-6 d-flex align-items-start input-container pb-4">
          <div class="form-floating flex-grow-1">
            <input
              id="search-input"
              v-model="input"
              class="form-control"
              placeholder="Your Search String"
              ref="searchTextField"
              dir="rtl"
            >
            <label for="search-input" class="text-end" dir="rtl">Your Search String</label>
            <small class="hint text-gray-100 fst-italic">Operators: e.g. 'OR', 'AND', 'NOT', '*' and more</small>
          </div>

          <a class="btn btn-outline-secondary ms-2" @click="toggleKeyboard" title="Open Keyboard">
            <svg xmlns="http://www.w3.org/2000/svg" width="32" height="32" fill="currentColor" class="bi bi-keyboard" viewBox="0 0 16 16">
              <path d="M14 5a1 1 0 0 1 1 1v5a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h12zM2 4a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2H2z"/>
              <path d="M13 10.25a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm0-2a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm-5 0A.25.25 0 0 1 8.25 8h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 8 8.75v-.5zm2 0a.25.25 0 0 1 .25-.25h1.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-1.5a.25.25 0 0 1-.25-.25v-.5zm1 2a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm-5-2A.25.25 0 0 1 6.25 8h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 6 8.75v-.5zm-2 0A.25.25 0 0 1 4.25 8h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 4 8.75v-.5zm-2 0A.25.25 0 0 1 2.25 8h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 2 8.75v-.5zm11-2a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm-2 0a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm-2 0A.25.25 0 0 1 9.25 6h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 9 6.75v-.5zm-2 0A.25.25 0 0 1 7.25 6h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 7 6.75v-.5zm-2 0A.25.25 0 0 1 5.25 6h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5A.25.25 0 0 1 5 6.75v-.5zm-3 0A.25.25 0 0 1 2.25 6h1.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-1.5A.25.25 0 0 1 2 6.75v-.5zm0 4a.25.25 0 0 1 .25-.25h.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-.5a.25.25 0 0 1-.25-.25v-.5zm2 0a.25.25 0 0 1 .25-.25h5.5a.25.25 0 0 1 .25.25v.5a.25.25 0 0 1-.25.25h-5.5a.25.25 0 0 1-.25-.25v-.5z"/>
            </svg>
          </a>
          <div class="card keyboard-container shadow" v-if="showKeyboard">
            <div class="button-container pa-2">
              <div class="btn-group">
                <div
                  class="btn btn-sm btn-outline-secondary"
                  :class="{active: selectedKeyboardLayout === 0}"
                  @click="selectedKeyboardLayout = 0"
                >
                  Arabic
                </div>
                <div
                  class="btn btn-sm btn-outline-secondary"
                  :class="{active: selectedKeyboardLayout === 1}"
                  @click="selectedKeyboardLayout = 1"
                >
                  Syriac
                </div>
              </div>
              <button type="button" class="btn button-close" aria-label="Close" @click="closeKeyboard">
                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="currentColor" class="bi bi-x" viewBox="0 0 16 16">
                  <path d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708z"/>
                </svg>
              </button>
            </div>
            <Keyboard
              @change="onChange"
              @key-press="onKeyPress"
              :input="input"
              :layout="keyboardLayouts[selectedKeyboardLayout]"
            />
          </div>
        </div>
        <div class="col-lg-2">
          <button class="btn btn-lg btn-primary" type="submit">Start Search</button>
        </div>
      </div>
  </form>
</template>
<script>
import Keyboard from "./Keyboard.vue";
export default {
  components: { Keyboard },
  data() {
    return {
      input: '',
      showKeyboard: false,
      selectedKeyboardLayout: 0,
      keyboardLayouts: ['arabic', 'syriac']
    }
  },
  mounted(){
    if(this.$route.query?.searchTerm){
      this.input = this.$route.query.searchTerm;
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      this.emitSearch();
      this.closeKeyboard();
    },
    emitSearch() {
      this.$emit('search', this.input);
    },
    onChange(input) {
      this.input = input;
      setTimeout(() => this.$refs.searchTextField.focus());
    },
    toggleKeyboard() {
      if (this.showKeyboard) {
        this.closeKeyboard();
      } else {
        this.openKeyboard();
      }
    },
    onKeyPress(button) {
      if (button === '{enter}') {
        this.emitSearch();
        this.closeKeyboard();
      }
    },
    openKeyboard() {
      this.showKeyboard = true;
      this.$refs.searchTextField.focus();
    },
    closeKeyboard() {
      this.showKeyboard = false;
      this.$refs.searchTextField.blur();
    }
  }
}
</script>

<style lang="scss" scoped>
.form-floating > label {
  left: auto;
  right: 0;
  padding-top: 0.8rem;
  padding-bottom: 0.8rem;
}
.form-floating > .form-control:focus ~ label, .form-floating > .form-control:not(:placeholder-shown) ~ label {
  color: var(--c-text-lighter);
  transform: scale(0.8) translateY(-2.6rem) translateX(2.3rem);
}

.form-control, label, .hint {
  color: var(--c-text);
  background: none;
}

label {
  &:after {
    content: none !important;
  }
}

.hint {
  color: var(--c-text-lighter);
}

.input-container {
  position: relative;
}

#search-input {
  height: calc(3rem + calc(var(--bs-border-width) * 2));
  padding-top: 0.8rem;
  padding-bottom: 0.8rem;
}

.btn-primary {
  font-size: 1rem;
  padding-top: 0.7rem;
  padding-bottom: 0.7rem;
}

.btn {
  svg {
    transform: translateY(2px);
  }
}

.keyboard-container {
  position: absolute;
  z-index: 100;
  width: 600px;
  top: 90%;
  max-width: none;

  @media (max-width: 719px) {
    width: 93vw;
  }

  .button-container {
    flex: 1;
    display: flex;
    align-items: center;
    margin-left: 8px;

    .btn {
      border-width: var(--bs-btn-border-width);
    }
  }
  .button-close {
    margin-left: auto;
  }
}
</style>
